function net = ahrbf(varargin)
% AHRBF Constructor for an adaptive hyprplane radial basis
%   function network
%   AHRBF(nin,nhid,nout,learnp,irange,vers);
%       nin     - number of inputs
%       nhid    - number of bases per input dimension
%       nout    - number of outputs
%       learnp  - learning rate
%       irange  - input range
%       vers    - version of getcenter to use [1 2 3]

% Satrajit Ghosh, SpeechLab, Boston University. (c)2001
% $Header: /mnt/localhd/cvsdir/MODELLING/NEWDIVA/@ahrbf/ahrbf.m,v 1.1.1.1 2006/10/06 18:20:23 brumberg Exp $

% $NoKeywords: $

% Setup globals
global RELEASE

switch nargin
case 0,
    net = rbfnet(1,1,1,1,1,1);
    net = class(net,'ahrbf');  
case 1    
    % if single argument of class operator, return it
    if (isa(varargin{1},'ahrbf'))
        net = varargin{1};
   else
        error('Wrong argument type')
    end 
case 6,
    % create object using specified values
    net = rbfnet(varargin{:});
    net = class(net,'ahrbf');  
otherwise
    error('Wrong number of input arguments')
end
