function net = updatevw(net,err)
% UPDATEVW Updates the weight vectors based on error and last input

% Satrajit Ghosh, SpeechLab, Boston University. (c)2001
% $Header: /mnt/localhd/cvsdir/MODELLING/NEWDIVA/@ahrbf/private/updatevw.m,v 1.1.1.1 2006/10/06 18:20:23 brumberg Exp $

% $NoKeywords: $

% Calculate delta value for udating network weights
delta = net.h*err';

% Update the weights of the output layer and the distance matrix layer
% The equations for update are derived from network equations
net.v = net.v + net.alpha*delta';
net.w = net.w + net.alpha*permute(delta(:,:,ones(1,1,net.nin)),[3 1 2]).*net.c(:,:,ones(1,1,net.nout));

% TODO: Update centers and variances
