function  b = subsref(net,index)
%SUBSREF Define field name indexing for ahrbf objects
%   Access contents of the elements of the net. One is not allowed
%   to modify these contents.
%   See class documentation for Matlab for explanation of this 
%   function

% Satrajit Ghosh, SpeechLab, Boston University. (c)2001
% $Header: /mnt/localhd/cvsdir/MODELLING/NEWDIVA/@ahrbf/subsref.m,v 1.1.1.1 2006/10/06 18:20:23 brumberg Exp $

% $NoKeywords: $

switch index.type
case '()'
    error('Array indexing not supported by operator objects')
case '.'
    switch index.subs
    case 'nin',
        b = net.nin;
    case 'nout',
        b = net.nout;
    case 'c'
        b = net.c;
    case 'h'
        b = net.h;
    case 'v'
        b = net.v;
    case 'w'
        b = net.w;
    case 'mu'
        b = net.mu;
    case 'sg'
        b = net.sg;
    otherwise
        error('Invalid field name')
    end
case '{}'
    error('Cell array indexing not supported by operator objects')
end