% VTSIMUL Sets up various constants and structures for use with AMgetdata

% Satrajit Ghosh, SpeechLab, Boston University. (c)2001
% $Header: /mnt/localhd/cvsdir/MODELLING/NEWDIVA/@d_opvt/private/vtsimul.m,v 1.1.1.1 2006/10/06 18:20:23 brumberg Exp $

% $NoKeywords: $

% Setup globals
global RELEASE

OFF		= 0;
ON			= 1;
RIGID		= 0;
YIELDING	= 1;
FLOW		= 0;
PRESSURE = 1;
CLOSE		= 0;
OPEN		= 1;
SHORT_CIRCUIT	= 0;
RL_CIRCUIT		= 1;
BESSEL_FUNCTION= 2;

TIME_VARYING	= 1;
STATIONARY		= 0;

UNIFROM_TUBE	= 0;
FROM_FILE		= 1;
T2MODEL			= 2;
P3MODEL			= 3;
ART_MODEL		= 4;

Utube_par = struct(...
   'area',6.0,...
   'length',17.5,...
   'nss',17,...
   'anc',0);
T2model_par = struct(...
   'A1',1.5,...
   'x1',8.5,...
   'A2',8.0,...
   'x2',8.5,...
   'anc',0);
P3model_par = struct(...
   'At',2.6,...
   'Xt',8.0,...
   'Al',4.0,...
   'anc',0);

AMmodel_par = struct(...
   'vowel',0,...
   'ampar',zeros(1,7),...
   'anc',0);

nss = 17;
af(1,:) = 6*ones(1,nss);
af(2,:) = (17.5/nss)*ones(1,nss);
AS2Fmodel_par = struct(...
   'nss',nss,...
   'af',af,...
   'length',17.5,...
   'nts',nss,...
   'anc',0);

tract_cfg = struct(...
   'rad_boundary',RL_CIRCUIT,...
   'wall',YIELDING,...
   'nasal_tract',OFF,...
   'glt_boundary',CLOSE);

phys_const = struct(...
   'ro',1.14e-3,...			% air density
   'c',3.5e+4,...				% sound velocity
   'wall_resi',1600,...
   'wall_mass',1.5,...
   'wall_comp',3e+5);

data = struct(...
   'TC',tract_cfg,...
   'PC',phys_const,...
   'UTmpar',Utube_par,...
   'T2mpar',T2model_par,...
   'P3mpar',P3model_par,...
   'AMpar',AMmodel_par,...
   'AS2Fpar',AS2Fmodel_par);
