function [data] = synthX(vtm,X,params)
% SYNTH1    Synthesizes the output from the vocal tract
%       1. Y = synth1(vtm,data);
%           In this case the input data contains the following
%           subfields: Ag0, AgP, F0, Af, dx, fs, duration

% Satrajit Ghosh, SpeechLab, Boston University. (c)2001
% $Header: /mnt/localhd/cvsdir/MODELLING/NEWDIVA/@d_opvt/synthX.m,v 1.1.1.1 2006/10/06 18:20:23 brumberg Exp $

% $NoKeywords: $

% Setup globals
global RELEASE

X=cat(2,X(:,1),X);
[N,Nt]=size(X);
if N~=10, 
  error('wrong dimensionality'); 
end

data.fs = params.vtcalc_fs; 
data.duration = params.TimeStep*Nt*1000;
data.X = X(1:7,:);
data.P = X(9,:);
time = 1000*params.TimeStep*(0:Nt-1)';
interp = 1*ones(Nt,1);
data.Ag0 = [time,X(8,:)',interp]; 
data.Ag0(1,3)=0;
data.AgP = [time,X(9,:)',interp]; 
data.AgP(1,3)=0;
data.F0 = [time,X(10,:)',interp]; 
data.F0(1,3)=0;
data = diva_synthX(data);

if params.vtcalc_fs~=params.fs, data.sig=resample(data.sig,params.fs,params.vtcalc_fs); end
data.sig=data.sig+.0001*randn(size(data.sig));

