function out=DIVA_Template(varargin);
% DIVA_Template DIVA module template
%
% Explanation of what this module does
%
% DIVA_Template('init' [,SessionName]);          Initializes the module
% DIVA_Template('save' [,SessionName] );         Saves state 
% DIVA_Template('exit');                         Exits the module (without saving)
% DIVA_Template(PropertyName [,PropertyValue] )  Reads and writes internal model properties
%
% DIVA_Template(ChannelName1,ChannelValue1,...
%               ChannelName2,ChannelValue2,...); Executes module process(es)
%

% Dependencies: 
%

%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
% This is a template for any new DIVA module.
% CHANGE any occurrence of 'DIVA_Template' to 'DIVA_ModuleName' everywhere in this 
% file (including the file name)
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%

out=[];
global DIVA_Template_data

for indexargin=1:2:nargin,  
    switch(varargin{indexargin}),
        case 'init',
            SessionFolder=strcat(DIVA('SessionFolder'),filesep);
            if nargin<indexargin+1 | isempty(varargin{indexargin+1}), initfile=''; 
            else, initfile=[SessionFolder,'Session_',varargin{indexargin+1},filesep,mfilename,'.mat']; end
            if isempty(initfile) | isempty(dir(initfile)),
                disp([mfilename, ' : Defining new session...']);
                % INITIALIZES INTERNAL MODULE PARAMETERS %%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%              
                DIVA_Template_data.params=struct(...);  
                    % %%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
                
            else,
                data=load(initfile,'-mat');
                DIVA_Template_data.params=data.params;
            end
            % INITIALIZES OTHER (TEMPORAL) PARAMETERS %%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%               
            DIVA_Template_data.params.current=struct(...);   
                % %%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
            
            % LIST OF MODULE CHANNELS %%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
            out={};
            %out={'ChannelName1','ChannelName2',...};   
            % %%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
            
        case 'save',
            SessionFolder=strcat(DIVA('SessionFolder'),filesep);
            if nargin<indexargin+1, initfile=[SessionFolder,'Session_','default',filesep,mfilename,'.mat'];
            else, initfile=[SessionFolder,'Session_',varargin{indexargin+1},filesep,mfilename,'.mat']; end
            params=DIVA_Template_data.params;
            save(initfile,'params'); 
            
        case 'exit',
            clear DIVA_Template_data;
            % CODE FOR CLEARING MEMORY OR THE LIKE %%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%              
            % %%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
            
        case 'disp',
            disp(DIVA_Template_data.params);
            out=fieldnames(DIVA_Microphone_data.params);

            % CODE IMPLEMENTING THIS MODULE PROCESS(ES) %%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%               
            % Note: use DIVA(ModuleName,ChannelName,data,delay) to comunicate with other DIVA modules
        case 'ChannelName1',
        case 'ChannelName2',
            ...
                % %%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
            
        otherwise,
            if isfield(DIVA_Template_data.params,varargin{indexargin}),
                if indexargin==nargin, out=DIVA_Template_data.params.(varargin{indexargin}); 
                else, DIVA_Template_data.params.(varargin{indexargin})=varargin{indexargin+1}; end
            else, warning('DIVA_Template: wrong argument'); end
    end
end
