function gui_file_menu_cbk(src,eventdata,options)
  switch(get(src,'tag')),
    %--------------------Exit Model--------------------------%
   case 'exit',
    status=questdlg('Do you wish to exit the GUI and model?', ...
                    'Exit?', ...
                    'GUI','GUI and Model','No','No');
    switch status,
     case 'GUI',
      save_stat=questdlg('Save GUI state?','Save?','Yes','No','Yes');
      if(strcmp('Yes',save_stat))
        DIVA('GUI','save');
      end
      DIVA('removemodule','GUI');
     case 'GUI and Model',
      save_stat=questdlg('Save DIVA state?','Save?','Yes','No','Yes');
      if(strcmp('Yes',save_stat))
        DIVA('save');
      end;
      DIVA('exit');
     otherwise
      msgbox('Exit Cancelled');
    end

    %----------------------- Create a new session-----------------%
   case 'new',
    sessionname=inputdlg('Session Name: ', 'New Session...',1);
    while(~isempty(sessionname) & ...
          exist(fullfile('sessions',char(sessionname)),'dir')==7)
      sessionname=inputdlg('Session Name Taken, try again', ...
                           'New Session...',1);
    end
    if(~isempty(sessionname))
      %    close(gcf);
      DIVA('init',sessionname{1});
    end

    %---------------------------Load a saved session------------------%
   case 'load',
    loadhandle=dialog('name','Load Session...','units','norm',...
                      'position',[.45 .45 .15 .15]);
    sessiondirs=dir('Sessiondata');
    j=1;
    for i=3:length(sessiondirs)
      if(sessiondirs(i).isdir)
        sessions{j}=sessiondirs(i).name(9:end);
        j=j+1;
      end
    end
    session=sessions{1};
    loadmenu=uicontrol('Style','popupmenu','parent',loadhandle,...
                       'Tag','session_load_menu',...
                       'String',sessions,'units','norm',...
                       'position',[0.1 0.7 0.8 0.2]);
    loadbutton=uicontrol('Style','pushbutton','parent',loadhandle,...
                         'Tag','session_load_button',...
                         'String','Load','units','norm',...
                         'position',[0.1 0.1 0.4 0.2],...
                         'Callback',{@loadmenu_cbk,loadmenu,sessions});
    cancelbutton=uicontrol('Style','pushbutton','parent',loadhandle,...
                           'Tag','session_cancel_button',...
                           'String','Cancel','units','norm',...
                           'position',[0.5 0.1 0.4 0.2],...
                           'Callback','close(gcf)');

    %------------------------------Save a session------------------------%
   case 'save',
    status=questdlg('Save Model State?','Save...','Yes','No','Yes');
    if(strcmp(status,'Yes'))
      DIVA('save');
    else
      msgbox('Save Cancelled');
    end

    % -----------------------Capture a screenshot----------------------%
   case 'screenshot',
    if(nargin>=3)
      if(ishandle(options))
        print(options,'-djpeg90','screenshot.jpg');
      end
    end

    %---------------------------Save last production as WAV------------%
   case 'sound',
    [y,fs]=getSynthSound();
    [fname,pname]=uiputfile('*.wav','Save as');
    if(~isempty(fname))
      wavwrite(y,fs,[pname,filesep,fname]);
    end

    %-----------------Save last production as A/V MOV------------------%
   case 'movie',
    [y,fs,motor]=getSynthSound();
    
    h=figure('position',[50 50 640 480],'menubar','none','doublebuffer','on');
    wh=waitbar(0,sprintf('%d%% complete',0),'position',[50 700 300 70]);
    figure(h);
    [fname,pname]=uiputfile('*.mov','Save as');
    if(~isempty(fname))
      MakeQTMovie('start',[pname,filesep,fname]);
      MakeQTMovie('size',[640 480]);
      MakeQTMovie('quality',0.8);
      for n=1:5:length(motor),
        figure(h);
        DIVA('VocalTract','plot',motor(1:end-3,n)); axis equal; axis off;
        MakeQTMovie('addaxes');
        waitbar(n/length(motor),wh,sprintf('%d%% complete',round(100*n/length(motor))));
      end
      MakeQTMovie('frameRate',200);
      MakeQTMovie('addsound',y,fs);
      MakeQTMovie('finish');
    end
    close(h);
    close(wh);
  end