function gui_model_cbk(src,eventdata,options)
  switch(get(src,'tag')),
   case 'menu',
    % Callback for learned sounds menu
    targets=DIVA('AuditoryCortexCategorical','AuditoryTargets');
    for n=1:length(targets),
      names{n}=targets(n).label;
    end
    selIdx=get(src,'value');
    if(selIdx~=1)
      selected=get(src,'String');
      selStr=selected{selIdx};
      idx=findstr('(',selStr);
      match = strmatch(selStr(1:idx-2),names,'exact');
      DIVA('AuditoryCortexCategorical','match',match-1);            
      DIVA('GUI','AC_WeightsFromTargets','target');
      % maintain current_file with selected target for Glottal param purposes
      auTarget.filename=[selStr(1:idx-2),'.mat'];
      auTarget.pathname=['.',filesep,'Sessiontargets',filesep,'Session_',DIVA('SessionName'),filesep];
      DIVA('GUI','auTarget',auTarget);
      DIVA('GUI','train_sound',1);

      % disable play button, enable produce button
      matchstart = (match-1)*DIVA('AuditoryCortexCategorical','ntimepoints');
      motorweights=DIVA('MotorCortex','WeightsFromTargets');
      if(~isempty(motorweights))
        if(matchstart < size(motorweights,2) - ...
           DIVA('AuditoryCortexCategorical','ntimepoints')),...
              producef='on';
        else
          producef='off';
        end
      else
        producef='off';
      end
      if(exist(fullfile('RESULTS','movies',['Session_',DIVA('SessionName')],...
                        [selStr(1:idx-2),'.mov']),'file'))
        playf='on';
      else
        playf='off';
      end
      DIVA('GUI','play',playf,'produce',producef);
    end
    %-----------------------------------------------------------%

   case 'play', % Change to reflect selected "stored target"
    target=DIVA('AuditoryCortexCategorical','AuditoryTargets');
    trained_sound=target(DIVA('AuditoryCortexCategorical','match')+1).label;

    % Play most recently produced sound
    if(DIVA('GUI','AutoMovie'))
      if(exist(fullfile('RESULTS','movies',['Session_',DIVA('SessionName')]),'dir'))
        pname = fullfile('RESULTS','movies',['Session_',DIVA('SessionName')]);      
        web(['file:///',pwd,filesep,pname,filesep,[trained_sound,'.mov']],'-browser');
      end
    else
      [sound,fs]=getSynthSound();
      soundview(sound,fs);
    end

    %-----------------------------------------------------------%

   case 'produce',
    % Simulate model based on learned weights
    % NO learning for production trials

    old_WeightLearn.motor=DIVA('MotorCortex','WeightLearn');
    old_WeightLearn.somato=DIVA('SomatosensoryCortex','eps_learn');

    % Set weights to 0 for NO learning condition
    DIVA('MotorCortex','WeightLearn',0);
    DIVA('SomatosensoryCortex','eps_learn',0);

    old_blockmode=DIVA('BlockMode');
    DIVA('BlockMode',1);

    target=DIVA('AuditoryCortexCategorical','AuditoryTargets');
    trained_sound=target(DIVA('AuditoryCortexCategorical','match')+1).label;
    DIVA('AuditoryCortexCategorical','target',trained_sound);
    DIVA('simulate');

    searchTarg = DIVA('MotorCortex','target',[],DIVA('TimeStep')*(-1000:0));
    idx=getQueueIdx(searchTarg);
    motor = DIVA('VocalTract','motor',[],DIVA('TimeStep')*(-idx:0));
    targ = searchTarg(1000-idx+1:end);
    [targ motor]=chompIdx(targ,motor);

    %DIVA('GUI','VT_Configuration',motor);


    % Reset learning rates to previous values
    DIVA('MotorCortex','WeightLearn',old_WeightLearn.motor);
    DIVA('SomatosensoryCortex','eps_learn',old_WeightLearn.somato);
    DIVA('BlockMode',old_blockmode);

    DIVA('GUI','AC_WeightsFromTargets','update');
    DIVA('GUI','other_weights',[]);

    % enable play button
    DIVA('GUI','play','on');
    [y,fs,motor]=getSynthSound(trained_sound);
    DIVA('GUI','Cochlea_plot',y);
    if(DIVA('GUI','AutoMovie'))
     produceAutoMovie(y,fs,motor,trained_sound);
    end

    %-----------------------------------------------------------%

   case 'browse',
    % Browse for target file
    browse_files;

    %-----------------------------------------------------------%

   case 'mic',
    % Specify target via microphone

    %-----------------------------------------------------------%

   case 'acquire',
    train_sound=DIVA('GUI','train_sound');

    if(train_sound == 1)
      fname=DIVA('GUI','current_file');
      au_info=load(fname);
      DIVA('SoundChannel','sound',au_info.f.mean');
      DIVA('AuditoryCortexCategorical','label',au_info.name);
      DIVA('simulate');
      DIVA('GUI','ACC_AuditoryTargets','update');
    end

    %-----------------------------------------------------------%

   case {'reset'}
    %     % clear model weight parameters, need to clear state values too!
    %     matchstart = DIVA('AuditoryCortexCategorical','ntimepoints')*...
    %         DIVA('AuditoryCortexCategorical','match')+1;
    %     matchend=matchstart+DIVA('AuditoryCortexCategorical','ntimepoints')-1;
    
    %     % Reset Motor Weights
    %     motorweight=DIVA('MotorCortex','WeightsFromTargets');
    %     motorweight(:,matchstart:matchend)=...
    %         repmat(DIVA('MotorCortex','default_motorSound'),1,...
    %                DIVA('AuditoryCortexCategorical','ntimepoints'));
    %     DIVA('MotorCortex','WeightsFromTargets',motorweight);
    
    %     % Reset Somatosensory Weights
    %     somatoweight=DIVA('SomatosensoryCortex','WeightsFromTargets');
    %     somatoweight(:,matchstart:matchend)=...
    %         repmat(DIVA('SomatosensoryCortex','default_somatosensory'),1,...
    %                DIVA('AuditoryCortexCategorical','ntimepoints'));
    %     DIVA('SomatosensoryCortex','WeightsFromTargets',somatoweight);
    
    %     % Reset stored training trials
    %     tmp=DIVA('AuditoryCortexCategorical','AuditoryTargets');
    %     tmp(DIVA('AuditoryCortexCategorical','match')+1).ntrained=0;
    %     DIVA('AuditoryCortexCategorical','AuditoryTargets',tmp);
    DIVA('reset');
    DIVA('GUI','ACC_AuditoryTargets','update');

    %-----------------------------------------------------------%

   case {'train'},
    % Train or Retrain model on specified target

    target=DIVA('AuditoryCortexCategorical','AuditoryTargets');
    trained_sound = target(DIVA('AuditoryCortexCategorical','match')+1).label;
    progWin = waitbar(0,sprintf('Training %d%% complete',0));
    nTrain = DIVA('GUI','nTrain');

    for i=1:nTrain,
      DIVA('AuditoryCortexCategorical','target',trained_sound);
      DIVA('simulate');
      DIVA('GUI','AC_WeightsFromTargets','update');
      DIVA('GUI','other_weights',[]);
      waitbar(i/nTrain,progWin,sprintf('Training %d%% complete',round(100*i/nTrain)));
      [y,fs,motor]=getSynthSound(trained_sound);
      DIVA('GUI','Cochlea_plot',y);
      DIVA('GUI','ACC_AuditoryTargets','update');
%           DIVA('AuditoryCortexCategorical','AuditoryTargets'));
    end
    close(progWin);

    % enable play button, enable produce button
    DIVA('GUI','play','on','produce','on');
    [y,fs,motor]=getSynthSound(trained_sound);
    DIVA('GUI','Cochlea_plot',y);

    % Create Movie
    if(DIVA('GUI','AutoMovie'))
      produceAutoMovie(y,fs,motor,trained_sound);
    end

    %-----------------------------------------------------------%

   case 'other',
    DIVA('GUI','other_weights',[]);

  end

function produceAutoMovie(y,fs,motor,name)

  h=figure('position',[50 50 640 480],'menubar','none','doublebuffer','on');
  wh=waitbar(0,sprintf('%d%% complete',0),'position',[50 700 300 70]);
  figure(h);
  if(~exist(fullfile('RESULTS','movies',['Session_',DIVA('SessionName')]),'dir'))
    mkdir(fullfile('RESULTS','movies',['Session_',DIVA('SessionName')]));
  end
  pname = fullfile('RESULTS','movies',['Session_',DIVA('SessionName')]);
  if(nargin==4)
    fname = [name,'.mov'];
  else
    fname ='lastheard.mov';
  end
  if(~isempty(fname))
    MakeQTMovie('start',[pname,filesep,fname]);
    MakeQTMovie('size',[640 480]);
    MakeQTMovie('quality',0.8);
    for n=1:5:length(motor),
      figure(h);
      if(size(motor,1)>DIVA('MotorCortex','nMotor'))
        DIVA('VocalTract','plot',motor(1:end-3,n)); axis equal; axis off;
      else
        DIVA('VocalTract','plot',motor(:,n)); axis equal; axis off;
      end
      MakeQTMovie('addaxes');
      waitbar(n/length(motor),wh,sprintf('%d%% complete',round(100*n/length(motor))));
    end
    MakeQTMovie('frameRate',200);
    MakeQTMovie('addsound',y,fs);
    MakeQTMovie('finish');
  end
  close(h);
  close(wh);

  %web(['file:///',pwd,filesep,'RESULTS',filesep,'movies',filesep,'lastheard.mov'],'-browser');
  web(['file:///',pwd,filesep,pname,filesep,fname],'-browser');

%   im=ReadQTMovie('start',[pname,fname]);
%   for n=1:length(im.frame_pos),
%     mov(n)=im2frame(ReadQTMovie('getframe',n));
%   end
%   ReadQTMovie('close');
%   soundview(y,fs);
%   mplay(mov,200);

