function gui_params_menu_cbk(src,eventdata,options)
  if(strcmp(get(src,'tag'),'glot_params'))
    % Plot Glottis parameters
    
    fname = DIVA('GUI','current_file');
    au_info=load(fname);
    figure,
    subplot(2,1,1)
    plot(au_info.Ag0(:,1),au_info.Ag0(:,2),'b',...
         au_info.AgP(:,1),au_info.AgP(:,2),'r');
    legend({'Ag0','AgP'});
    
    subplot(2,1,2)
    plot(au_info.F0(:,1),au_info.F0(:,2),'b');
    legend('F0');
    
  else
    % Edit system parameters
    if(strcmp(options.module,'DIVA'))
      current = DIVA(options.param);
    else
      current = DIVA(options.module,options.param);
    end
    if(strcmp(options.param,'BlockMode')),
      if(strcmp(get(src,'Checked'),'on')),
        set(src,'Checked','off')
        DIVA('BlockMode',0);
      else
        set(src,'Checked','on');
        DIVA('BlockMode',1);
      end
    else
      answer = ...
          inputdlg([options.name,...
                    ' [',num2str(options.range(1)),'-',num2str(options.range(2)),'] '],...
                   ['Update ',options.module,' parameters'],1,{num2str(current)});
      
      if(~isempty(answer))
        new=str2num(answer{1});
        while(new<options.range(1) | new>options.range(2)),
          answer = ...
              inputdlg(sprintf('Choose value within range \n%s',[options.name,...
                              ' [',num2str(options.range(1)),'-',num2str(options.range(2)),'] ']),...
                       ['Update ',options.module,' parameters'],1,{num2str(current)});
          if(isempty(answer))
            return;
          end      
          new=str2num(answer{1});
        end
        if(strcmp(options.module,'DIVA')),
          DIVA(options.param,new);
        else
          DIVA(options.module,options.param,new);
        end
      else
        return; 
      end
    end
  end