function gui_vocaltract_cbk(src,eventdata,options)
  switch(get(src,'tag'))
    %---------------------Set duration of VT simulation-----------------------%
   case {'duration'},
    value=str2num(get(src,'string'));
    DIVA('GUI','duration',value);
    
    %---------------------Reset/Randomize vocal tract configuration-----------%
   case {'random','reset'}
    if(strcmp(get(src,'tag'),'random'))
      names=options;
      config=round(100*((2*DIVA('VocalTract','MaedaSpread'))*...
                        (rand(length(names),1)-0.5)))/100;
      for i=1:length(names)
        params(i).name=names{i};
        params(i).value=config(i);
      end
    else
      names=options{1};
      glot_label=options{2};
      config=zeros(length(names),1);
      for i=1:length(names)
        params(i).name=names{i};
        params(i).value=config(i);
      end
      config=[];
      config=[0.01 0.2 100];
      for i=1:length(glot_label)
        params(i+length(names)).name=glot_label{i};
        params(i+length(names)).value=config(i);
      end
    end
    DIVA('GUI','artic_edit',params);
    DIVA('GUI','artic_slider',params);
    DIVA('GUI','VT_Configuration','update');
    artic=DIVA('GUI','artic_slider',[]);
    temp=DIVA('VocalTract','motor',artic);
    %DIVA('GUI','FmtSpace_crosshairs',mel(temp{1}));
    DIVA('GUI','FmtSpace_crosshairs',(temp{1}));
    DIVA('GUI','FmtValues',temp{1});

    %DIVA('GUI','Cochlea_plot','update');
    
    %----------------------------Set individual articulators/glottal params ----%%
   case 'articslider',
    set(src,'value',(round(get(src,'value')*100)/100));
    params.name=get(src,'UserData');
    params.value=get(src,'Value');
    DIVA('GUI','artic_edit',params);
    DIVA('GUI','VT_Configuration','update');
    artic=DIVA('GUI','artic_slider',[]);
    temp=DIVA('VocalTract','motor',artic);
    %DIVA('GUI','FmtSpace_crosshairs',mel(temp{1}));
    DIVA('GUI','FmtSpace_crosshairs',(temp{1}));
    DIVA('GUI','FmtValues',temp{1});
    %  DIVA('GUI','Cochlea_plot','update');

   case 'articedit',
    edit_value=str2double(get(src,'string'));
    if(abs(edit_value)>DIVA('VocalTract','MaedaSpread'))
      set(src,'string',...
              sprintf('%1.2f',(edit_value/abs(edit_value))*...
                      DIVA('VocalTract','MaedaSpread')));
    end
    set(src,'string',sprintf('%1.2f',(round(str2double(get(src,'string'))*100)/100)));
    params.name=get(src,'UserData');
    params.value=str2double(get(src,'string'));
    DIVA('GUI','artic_slider',params);
    DIVA('GUI','VT_Configuration','update');
    artic=DIVA('GUI','artic_slider',[]);
    temp=DIVA('VocalTract','motor',artic);
    %DIVA('GUI','FmtSpace_crosshairs',mel(temp{1}));
    DIVA('GUI','FmtSpace_crosshairs',(temp{1}));
    DIVA('GUI','FmtValues',temp{1});
    %  DIVA('GUI','Cochlea_plot','update');
    
   case 'glotslider',
    set(src,'value',(round(get(src,'value')*100)/100));
    params.name=get(src,'UserData');
    params.value=get(src,'Value');
    DIVA('GUI','artic_edit',params);

   case 'glotedit',
    edit_value=str2double(get(src,'string'));
    params=get(src,'UserData');
    if(edit_value > params.max | edit_value < params.min)
      set(src,'string',sprintf('%1.2f', (edit_value>params.max)*params.max+...
                               (edit_value<params.min)*params.min));
    end
    set(src,'string',sprintf('%1.2f',(round(str2double(get(src,'string'))*100)/100)));
    nparams.name=params.name;
    nparams.value=str2double(get(src,'string'));
    DIVA('GUI','artic_slider',nparams);

    %---------------------------Update cochlea plot (NEEDS NEW FUNCTION)-----%
   case 'set',
    %DIVA('GUI','Cochlea_plot','update');
    artic=DIVA('GUI','artic_slider',[]);
    temp=DIVA('VocalTract','motor',artic);
    %DIVA('GUI','FmtSpace_crosshairs',mel(temp{1}));
    DIVA('GUI','FmtSpace_crosshairs',(temp{1}));
    DIVA('GUI','FmtValues',temp{1});
    
    %------------------------------Generate sound from articulator config-----%
    
   case 'generate',
    artics=options{1};
    glots=options{2};
    
    outa=DIVA('GUI','artic_slider',artics);
    outg=DIVA('GUI','glot_slider',glots);
    f0=outg(3);
    m=[outa;outg];
    %  duration=inputdlg('Sound Duration (ms): ','Enter Sound Duration...',1,{'300'});
    %  if(isempty(duration))
    %    msgbox('Sound Canceled...');
    %  else
    %   duration=str2num(duration{1});
    duration = DIVA('GUI','duration');
    m=repmat(m,1,ceil(duration));
    % taper F0 for authentic sound
    m(end,:)=pchip([0 ceil(duration/3) ceil(duration)],[f0-5 f0 f0-.25*f0],0:ceil(duration)-1);
    sound = DIVA('VocalTract','synthsound',m);
    soundview(sound{1},sound{2});
    wavwrite(sound{1},sound{2},fullfile(pwd,'RESULTS','sounds','lastheard.wav'));
    DIVA('GUI','Cochlea_plot',sound{1});
    % soundview(sound,DIVA('VocalTract','fs'));
%    end  

    %-------------------------Learn sound produced from current config-------%
   case 'learn',
    artics=options{1};
    glots=options{2};
    
    outa=DIVA('GUI','artic_slider',artics);
    outg=DIVA('GUI','glot_slider',glots);
    f0=outg(3);
    fmt = DIVA('GUI','FmtValues');
    m=[outa;outg];
    desc=inputdlg({'Sound Label: ','Sound Duration (ms): '},...
                  'Sound Description...',1,{'','300'});
    if(isempty(desc))
      msgbox('Learning Canceled...');
    else
      label=desc{1};
      dur=str2num(desc{2});
      dur = ceil(dur);
      % taper F0 for authentic sound
      F0 = [(0:dur-1)' ...
             pchip([0 ceil(dur/3) dur],[f0-5 f0 f0-.25*f0],0:dur-1)' ...
             ones(dur,1)];
      AgP=[(0:dur-1)',repmat(outg(2),dur,1),ones(ceil(dur),1)];
      Ag0=[(0:dur-1)',repmat(outg(1),dur,1),ones(ceil(dur),1)];

      if(size(fmt,1)>size(fmt,2))
        fmt=fmt';
      end
      f.mean = repmat(fmt,dur,1);
      f.var =repmat([400 2500 10000],dur,1);      
      name = label;
      target.pathname=['Sessiontargets',filesep,'Session_',DIVA('SessionName'),filesep];
      target.filename=[label,'.mat'];
      save([target.pathname,target.filename],'f','Ag0','AgP','F0','dur','name');
      % set current file
      DIVA('SoundChannel','sound',f.mean');
      DIVA('AuditoryCortexCategorical','label',label);
      DIVA('simulate');
      DIVA('GUI','ACC_AuditoryTargets','update');
%           DIVA('AuditoryCortexCategorical','AuditoryTargets'));
      DIVA('GUI','auTarget',target);
      DIVA('GUI','train_sound');
    end
  end
