function au_fmt_space_init(hau,type)
% type can be 1,2,3 - male, female, child...default to male
  if(nargin==1)
    type=1;
  end
  [pb.type pb.num pb.vnum pb.vowel pb.f0 pb.f1 pb.f2 pb.f3]= ...
      textread('data/verified_pb.data','%d%d%d%s%f%f%f%f');
  
  vowel_ind=[];
  for j=1:length(pb.type)
    if(pb.type(j)==type)
      if isempty(findstr(char(pb.vowel(j)),'*'))
        if isfield(vowel_ind,char(pb.vowel(j)))
          vowel_ind.(char(pb.vowel(j)))(end+1)=j;
        else
          vowel_ind.(char(pb.vowel(j)))(1)=j;
        end
      end
    end
  end
  names=fieldnames(vowel_ind);
  gcolor={'b','g','r','c','m','y','k','b-','g-','r-'};
  axes(hau); hold on;
  gaussEllipse(names,pb,vowel_ind,gcolor);
%   xlim=mel([0 1200]);
%   ylim=mel([500 3500]);
%   xtick=(mel(linspace(0,1200,5)));
%   ytick=(mel(500:500:3500));
%   xticklabel=floor(linspace(0,1200,5));
%   yticklabel=floor(500:500:3500);

  xlim=[0 900];
  ylim=[500 3000];
  xtick=linspace(0,900,5);
  ytick=500:500:3000;
  xticklabel=floor(linspace(0,900,5));
  yticklabel=floor(500:500:3000);

  % above, labels are still in Hz, but plotting is mel scaled
  
  set(hau,'Xlim',xlim,'Ylim',ylim, 'YAxisLocation','left');%,'right');
  set(hau,'XTick',xtick,'YTick',ytick);
  set(hau,'XTickLabel',xticklabel,'YTickLabel',yticklabel);

%   xlabel('F1 Frequency (Mel Scaled Hz)');
%   ylabel('F2 Frequency (Mel Scaled Hz)');
  xlabel('F1 Frequency (Hz)');
  ylabel('F2 Frequency (Hz)');
  title('Acoustic Space');
  
  axis normal;
  
function gaussEllipse(names,pb,vowel_ind,gcolor)
% Find and plot ellipses defined by gaussian distribution using mean
% and covariance measured from Peterson and Barney 1952 database
  
% Replace means with better vowels -- Rabiner and Schafer and
% Empirical from DIVA experimentation
  
  F.IY=[270 2290 3010];  % iy
  F.IH=[390 1990 2550];  % ih
  F.EH=[519 1619 2411];  % eh  
  F.AE=[660 1720 2410];  % ae
  F.AH=[677 1419 2241];  % ah
  F.AA=[662 1251 2278];  % aa
  F.UH=[541 1097 2239];  % uh
  F.UW=[392 964 2233];   % oo
  F.ER=[490 1350 1690];  % er
  F.AO=[526 910.5 2108];   % ow
  
  for i=1:length(names)
    cur_dist=[pb.f1(vowel_ind.(char(names(i)))) pb.f2(vowel_ind.(char(names(i))))];
    mu=mean(cur_dist,1)';
    S=cov(cur_dist);
  
    mu=F.(char(names(i)))([1,2])';
    
    theta=linspace(0,2*pi,1000);
    [vv,dd]=eig(S*2); % 2 standard deviations?
    A=real((vv*sqrt(dd))');
    x=sin(theta);
    y=cos(theta);
    z=[x' y']*A;
    z=z+repmat(mu',1000,1);
    %z=mel(z);
    %mu=mel(mu);
    plot(z(:,1),z(:,2),char(gcolor(i)),'ButtonDownFcn',get(gca,'ButtonDownFcn'),...
         'tag',get(gca,'tag'),'parent',gca);
    text(mu(1),mu(2),char(names(i)),'ButtonDownFcn',get(gca,'ButtonDownFcn'),...
         'tag',get(gca,'tag'),'parent',gca);
  end
  return
