function [sound,fs,motor]=getSynthSound(varargin)
% Get normalized motor trajectories - VocalTract
% Get normalized target indices - MotorCortex
  if(nargin==0)
    searchIdx=DIVA('TimeStep')*(-1000:0);
    searchTarg=DIVA('MotorCortex','target',[],searchIdx);
    idx=getQueueIdx(searchTarg);
    motor=DIVA('VocalTract','motor',[],DIVA('TimeStep')*(-idx:0));
    [targ midx] = sort(searchTarg(1000-idx+1:end));
    idx=find(targ==0);
    targ(idx)=[];
    midx(idx)=[];
    motor=motor(:,midx);

    % Get Velocity information - AuditoryCortexCategorical
    % Rescale motor trajectories via velocity scaled target indices

    % Get Glottal information - AuditoryCortexCategorical
    fname = DIVA('GUI','current_file');
    au_info=load(fname);
    if(size(motor,2)~=size(au_info.Ag0,1))
      msize=size(motor,2)-size(au_info.Ag0,1)
      if(msize>0),
        motor(:,end-msize+1:end)=[];
      else
        au_info.Ag0(end-abs(msize)+1:end,:)=[];
        au_info.AgP(end-abs(msize)+1:end,:)=[];
        au_info.F0(end-abs(msize)+1:end,:)=[];
      end
    end
    motor = [motor;...
             au_info.Ag0(:,2)';...
             au_info.AgP(:,2)';...
             au_info.F0(:,2)'];

    out = DIVA('VocalTract','synthsound',motor);
    sound=out{1};
    fs = out{2};
  else,%specify same input to DIVA('AuditoryCortexCategorical','target',var)
    y=[];
    fs=10000;
    idxstart=0;
    glot=[];
    for n=1:length(varargin)
      if(ischar(varargin{n}))
        idxstart=idxstart + ...
                 length(DIVA('AuditoryCortexCategorical','target',varargin{n}))*DIVA('TimeStep');
        au_info=load([DIVA('SessionTargetFolder'),filesep,['Session_',DIVA('SessionName')],...
                      filesep,[varargin{n},'.mat']]);
        glot=[glot,[au_info.Ag0(:,2)';au_info.AgP(:,2)';au_info.F0(:,2)']];
        idx(n)=length(DIVA('AuditoryCortexCategorical','target',varargin{n}))*DIVA('TimeStep');
      else
        idxstart=idxstart+varargin{n};
        idx(n)=varargin{n};
        glot=[glot,[zeros(1,varargin{n}*1000);ones(1,varargin{n}*1000)*0.1;zeros(1,varargin{n}*1000)]];
      end
    end
    
    motor=DIVA('VocalTract','motor',[],...
               -(idxstart + ...
                 DIVA('SoundMap','delayToMotorCortex') + ...
                 DIVA('AuditoryCortexCategorical','delayToSoundMap') + ...
                 DIVA('MotorCortex','delayToerror_sound') + ...
                 DIVA('MotorCortex','delayToerror_somatosensory')):0.001:...
               -(1*DIVA('TimeStep')+DIVA('SoundMap','delayToMotorCortex') + ...
                 DIVA('AuditoryCortexCategorical','delayToSoundMap') + ...
                 DIVA('MotorCortex','delayToerror_sound') + ...
                 DIVA('MotorCortex','delayToerror_somatosensory')));
    x=1:size(motor,2);
    glot(3,:)=interp1([1 size(motor,2)/4 size(motor,2)],[90 120 80],x);
%    figure,subplot(3,1,1),plot(motor');
%    subplot(3,1,2),
%    hold on;
%    plot(glot(1,:),'b');
%    plot(glot(2,:),'r');
    out=DIVA('VocalTract','synthsound',[motor;glot]);
    sound=out{1};
    fs=out{2};    
%    subplot(3,1,3),
%    hold on;
    cumsum(idx);
    idx(1:2:end)=idx(1:2:end)-.006;
    idx(2:2:end)=idx(2:2:end)+0.009;
    cumsum(idx);
    for n=1:2:length(idx)-1,
%       line([sum(idx(1:n)) sum(idx(1:n))]*fs,[-1 1],'color','k');
%       line([sum(idx(1:n+1)) sum(idx(1:n+1))]*fs,[-1 1],'color','r');
      sound(round(sum(idx(1:n))*fs:sum(idx(1:n+1))*fs))=0;
    end
%    plot(sound)
  end
